sc::MemoryGrp(3)

NAME
sc::MemoryGrp -

The MemoryGrp abstract class provides a way of accessing distributed

 memory in a parallel machine.

SYNOPSIS

#include <memory.h>

Inherits sc::DescribedClass.

Inherited by sc::MsgMemoryGrp, and sc::ProcMemoryGrp.

  Public Member Functions
MemoryGrp (const Ref< KeyVal > &)
int me () const
Returns who I am.
int n () const
Returns how many nodes there are.
virtual void set_localsize (size_t)=0
Set the size of locally held memory.
size_t localsize ()
Returns the amount of memory residing locally on me().
virtual void * localdata ()=0
Returns a pointer to the local data.
distsize_t localoffset ()
Returns the global offset to this node's memory.
int size (int node)
Returns the amount of memory residing on node.
distsize_t offset (int node)
Returns the global offset to node's memory.
distsize_t totalsize ()
Returns the sum of all memory allocated on all nodes.
virtual void activate ()
Activate is called before the memory is to be used.
virtual void deactivate ()
Deactivate is called after the memory has been used.
virtual void * obtain_writeonly (distsize_t offset, int size)=0
This gives write access to the memory location. No locking is done.
virtual void * obtain_readwrite (distsize_t offset, int size)=0
Only one thread can have an unreleased obtain_readwrite at a time.
virtual void * obtain_readonly (distsize_t offset, int size)=0
This gives read access to the memory location. No locking is done.
virtual void release_readonly (void *data, distsize_t offset, int size)=0
This is called when read access is no longer needed.
virtual void release_writeonly (void *data, distsize_t offset, int size)=0
This is called when write access is no longer needed.
virtual void release_readwrite (void *data, distsize_t offset, int size)=0
This is called when read/write access is no longer needed.
virtual void sum_reduction (double *data, distsize_t doffset, int dsize)
virtual void sum_reduction_on_node (double *data, size_t doffset, int dsize, int node=-1)
virtual void sync ()=0
Synchronizes all the nodes.
virtual void * malloc_local (size_t nbyte)
Allocate data that will be accessed locally only.
virtual double * malloc_local_double (size_t ndouble)
virtual void free_local (void *data)
Free data that was allocated with malloc_local_double.
virtual void free_local_double (double *data)
virtual void catchup ()
Processes outstanding requests.
virtual void print (std::ostream &o=ExEnv::out0()) const
Prints out information about the object.

  Static Public Member Functions
static MemoryGrp * initial_memorygrp (int &argc, char **argv)
Create a memory group.
static MemoryGrp * initial_memorygrp ()
static void set_default_memorygrp (const Ref< MemoryGrp > &)
The default memory group contains the primary memory group to be used by an application.
static MemoryGrp * get_default_memorygrp ()
Returns the default memory group.

  Protected Member Functions
void obtain_local_lock (size_t start, size_t fence)
void release_local_lock (size_t start, size_t fence)

  Protected Attributes
int me_
int n_
distsize_t * offsets_
int debug_

Detailed Description

The MemoryGrp abstract class provides a way of accessing distributed

 memory in a parallel machine. Several specializations are available. For one processor, ProcMemoryGrp provides a simple stub implementation. Parallel specializations include ShmMemoryGrp, MTMPIMemoryGrp, and ARMCIMemoryGrp. The particular specializations that work depend highly on the target hardware and software environment.

Member Function Documentation

  virtual void sc::MemoryGrp::catchup () [virtual]

Processes outstanding requests. Some memory group implementations don't have access to real shared memory or even active messages. Instead, requests are processed whenever certain memory group routines are called. This can cause large latencies and buffer overflows. If this is a problem, then the catchup member can be called to process all outstanding requests.

  virtual void sc::MemoryGrp::free_local (void *data) [virtual]

Free data that was allocated with malloc_local_double.

Reimplemented in sc::ARMCIMemoryGrp.

  static MemoryGrp* sc::MemoryGrp::get_default_memorygrp () [static]

Returns the default memory group. If the default memory group has not yet been set, then one is created. The particular specialization used is determined by configuration options and which specializations are being used for MessageGrp and ThreadGrp.

  static MemoryGrp* sc::MemoryGrp::initial_memorygrp (int &argc, char **argv) [static]

Create a memory group. This routine looks for a -memorygrp argument, and then the environmental variable MEMORYGRP to decide which specialization of MemoryGrp would be appropriate. The argument to -memorygrp or the value of the environmental variable should be either string for a ParsedKeyVal constructor or a classname. The default ThreadGrp and MessageGrp objects should be initialized before this is called.

  virtual void* sc::MemoryGrp::malloc_local (size_tnbyte) [virtual]

Allocate data that will be accessed locally only. Using this for data that will be used for global operation can improve efficiency. Data allocated in this way must be freed with free_local_double.

Reimplemented in sc::ARMCIMemoryGrp.

  virtual void* sc::MemoryGrp::obtain_readwrite (distsize_toffset, intsize) [pure virtual]

Only one thread can have an unreleased obtain_readwrite at a time. The actual memory region locked can be larger than that requested. If the memory region is already locked this will block. For this reason, data should be held as read/write for as short a time as possible.

Implemented in sc::ActiveMsgMemoryGrp, sc::ShmMemoryGrp, sc::RDMAMemoryGrp, and sc::ProcMemoryGrp.

  virtual void sc::MemoryGrp::release_readwrite (void *data, distsize_toffset, intsize) [pure virtual]

This is called when read/write access is no longer needed. The memory will be unlocked.

Implemented in sc::ActiveMsgMemoryGrp, sc::ShmMemoryGrp, sc::RDMAMemoryGrp, and sc::ProcMemoryGrp.

  static void sc::MemoryGrp::set_default_memorygrp (const Ref< MemoryGrp > &) [static]

The default memory group contains the primary memory group to be used by an application.

  virtual void sc::MemoryGrp::set_localsize (size_t) [pure virtual]

Set the size of locally held memory. When memory is accessed using a global offset counting starts at node 0 and proceeds up to node n() - 1.

Implemented in sc::ActiveMsgMemoryGrp, sc::ShmMemoryGrp, sc::RDMAMemoryGrp, sc::ARMCIMemoryGrp, sc::ProcMemoryGrp, and sc::MsgMemoryGrp.

  virtual void sc::MemoryGrp::sync () [pure virtual]

Synchronizes all the nodes. This is useful after remote memory writes to be certain that all of the writes have completed and the data can be accessed locally, for example.

Implemented in sc::MTMPIMemoryGrp, sc::ARMCIMemoryGrp, sc::ProcMemoryGrp, and sc::MsgMemoryGrp.

Author

Generated automatically by Doxygen for MPQC from the source code.